jQuery(document).ready(function() {
	MonRect.mainAjax();
});

var MonRect = {
	intIdent: 0,
	
	ajaxCommand: function(xmlData) {
		jQuery(xmlData).children('xml').children('Command').each(function() {
			var strCommandCommand = jQuery(this).children('strCommand').text();
			var strCommandData = jQuery(this).children('strData').text();
			
			if (strCommandCommand === 'commandMove') {
				window.location = strCommandData;
			}
		});
	},
	
	mainAjax: function() {
		jQuery.ajax({
			'type': 'GET',
			'url': '/index.xml',
			'dataType': 'xml',
			'success': function(xmlData) {
				MonRect.ajaxCommand(xmlData);
				
				MonRect.mainAjaxArrive(xmlData);
			}
		});
	},
	
	mainAjaxArrive: function(xmlData) {
		{
			var intIdent = 0;
			
			jQuery(xmlData).children('xml').children('Monitor').children('Chart').each(function() {
				intIdent += 1;
			});
			
			if (MonRect.intIdent !== intIdent) {
				MonRect.intIdent = intIdent;
				
				jQuery(document.body)
					.empty()
				;
				
				jQuery(xmlData).children('xml').children('Monitor').each(function() {
					var strMonitorName = jQuery(this).children('strName').text();
					
					var jqMonitor = jQuery('<div></div>')
						.addClass('cssMonitor')
						.append(jQuery('<div></div>')
							.addClass('cssMonitorTitle')
							.text(strMonitorName)
						)
						.append(jQuery('<div></div>')
							.addClass('cssMonitorChartContainer')
							.append(jQuery('<table></table>')
								.css({
									'width': '100%'
								})
								.append(jQuery('<tr></tr>')
									
								)
							)
						)
					;
					
					jQuery(document.body)
						.append(jqMonitor)
					;
					
					jQuery(this).children('Chart').each(function() {
						var strChartColor = jQuery(this).children('strColor').text();
						var intChartData = parseInt(jQuery(this).children('intData').text(), 10);
						
						var jqMonitorChart = jQuery('<div></div>')
							.addClass('cssMonitorChart')
							.data({
								'contextHandle': {},
								'strChartColor': strChartColor,
								'chartDataHandle': []
							})
							.append(jQuery('<canvas></canvas>')
								.css({
									'display': 'block',
									'width': '100%',
									'height': '100px'
								})
							)
						;
						
						jqMonitor.children('.cssMonitorChartContainer').find('tr')
							.append(jQuery('<td></td>')
								.css({
									'width': '1%'
								})
								.append(jqMonitorChart)
							)
						;
					});
				});
				
				jQuery('.cssMonitorChart').each(function() {
					jQuery(this)
						.data({
							'contextHandle': jQuery(this).children('canvas').get(0).getContext('2d')
						})
					;
				});
			}
		}
		
		{
			jQuery(xmlData).children('xml').children('Monitor').each(function(intFor1) {
				var strMonitorName = jQuery(this).children('strName').text();
				
				var jqMonitor = jQuery('.cssMonitor').eq(intFor1);
				
				jQuery(this).children('Chart').each(function(intFor2) {
					var strChartColor = jQuery(this).children('strColor').text();
					var intChartData = parseInt(jQuery(this).children('intData').text(), 10);
					
					var jqMonitorChart = jqMonitor.children('.cssMonitorChartContainer').find('.cssMonitorChart').eq(intFor2);
					
					var contextHandle = jqMonitorChart.data('contextHandle');
					var chartDataHandle = jqMonitorChart.data('chartDataHandle');
					
					{
						var jqCanvas = jqMonitorChart.children('canvas');
						
						contextHandle.canvas.width = jqCanvas.width();
						contextHandle.canvas.height = jqCanvas.height();
					}
					
					{
						var intMax = contextHandle.canvas.width / 12;
						
						while (chartDataHandle.length > intMax) {
							chartDataHandle.pop();
						}
						
						chartDataHandle.unshift(intChartData);
					}
				});
			});
			
			jQuery('.cssMonitorChart').each(function() {
					var contextHandle = jQuery(this).data('contextHandle');
					var strChartColor = jQuery(this).data('strChartColor');
					var chartDataHandle = jQuery(this).data('chartDataHandle');
					
					{
						contextHandle.fillStyle = 'rgb(0, 0, 0)';
						contextHandle.fillRect(0, 0, contextHandle.canvas.width, contextHandle.canvas.height);
					}
					
					{
						contextHandle.fillStyle = 'rgb(' + strChartColor + ')';
						
						for (var intFor1 = 0; intFor1 < chartDataHandle.length; intFor1 += 1) {
							var intChartData = chartDataHandle[intFor1];
							
							var intHeight = Math.round((contextHandle.canvas.height - 4) * (intChartData / 100000.0));
							
							intHeight = Math.max(1, intHeight);
							intHeight = Math.min(contextHandle.canvas.height - 4, intHeight);
							
							var intX = 2 + (intFor1 * 12);
							var intY = contextHandle.canvas.height - (intHeight + 2);
							
							contextHandle.fillRect(intX, intY, 10, intHeight);
						}
					}
			});
		}
		
		window.setTimeout(function() {
			MonRect.mainAjax();
		}, 1000);
	}
};